with Mensajes_Bolsa;
with Lower_Layer_UDP;
with Ada.Characters.Handling;

package body Broker_HTTP is

   package MEN renames Mensajes_Bolsa;
   package LLUDP renames Lower_Layer_UDP;
   package ACH renames Ada.Characters.Handling;

   task body Servidor_HTTP is

      Peticion: ASU.Unbounded_String;
      -- Para separar la URL
      Tipopet, Inicio, Maquina, Puerto, Dirrel, Final: ASU.Unbounded_String;

      Pagina: ASU.Unbounded_String;

      TerminarTarea : Boolean:=False;

      Send_Stream: aliased Lower_Layer_UDP.Buffer_Type (1024);

      Serv_Conn: aliased LLTCP.Connection;
      Done: Boolean;

      A_Char: Character;
      --   A_String: String (1 .. 80);
      --   A_String_Filled: Integer;
      Almost_Done: Boolean := False;


      -- ************************************************************************************************
      -- Parte de un Unbounded, que contiene una peticin de tipo put, o get, y lo separa en partes:    *
      -- El tipo de peticin, el nombre de mquina, el puerto, la direccin relativa y lo que va detrs *
      -- ************************************************************************************************
      procedure Separar_URL (Peticion: ASU.Unbounded_String) is
         PeticionS: String(1..500);
         Tamano: Integer;
         Num, Num2, Num3: Integer;
      begin
         TipoPet:= ASU.Null_Unbounded_String;
         Inicio:= ASU.Null_Unbounded_String;
         Maquina:= ASU.Null_Unbounded_String;
         Puerto:= ASU.Null_Unbounded_String;
         DirRel:= ASU.Null_Unbounded_String;
         Final:= ASU.Null_Unbounded_String;

         Tamano:= ASU.To_String(Peticion)'Length;
         PeticionS(1..Tamano):= ASU.To_String(Peticion);
         TIO.Put_Line ("La PETICIN A SEPARAR es: " & ASU.To_String(Peticion));

         -- Sacar el tipo de peticin, si es un GET o un PUT
         Num:= ASU.Index (Peticion, "GET");
         if Num>0 then
            Num2:= Num+4;
            TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
         else
            Num:=ASU.Index (Peticion, "PUT");
            if Num>0 then
               Num2:=Num+4;
               TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
            else
               TIO.Put_Line ("ERROR: No se ha encontrado ninguna peticin");
            end if;
         end if;

         -- Sacar lo que hay despus del GET o del PUT, pero antes del nombre de mquina, "siempre" http://
         Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), "http://");
         Inicio:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num+5));
         Num2:=Num2+Num+6;

         -- Sacar el nombre de la mquina
         Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), ":");
         if Num>0 then
            Maquina:=ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
            Num2:=Num2+Num;

            -- Saco el nmero de puerto
            Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano)),"/");
            if Num>0 then
               Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
               Num2:=Num2+Num-1;
            else
               Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano))," ");
               Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
               Num2:= Num2+Num;
            end if;
            if (PeticionS(Num2)='/') then
               Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
               DirRel:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
               Num2:=Num2+Num-1;
            else
               DirRel:= ASU.To_Unbounded_String("/");
            end if;
         else
            Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)),"/");
            Num3:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-1))," ");
            if (Num>0 and Num3=0)then
               Maquina:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
               Num2:=Num2+Num-1;
               Puerto:= ASU.To_Unbounded_String ("80");
               if (PeticionS(Num2)='/') then
                  Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
                  DirRel:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
                  Num2:=Num2+Num-1;
               else
                  DirRel:= ASU.To_Unbounded_String("/");
               end if;
            else
               Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
               Maquina:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
               Puerto:= ASU.To_Unbounded_String ("80");
               DirRel:= ASU.To_Unbounded_String("/");
               Num2:=Num2+Num-1;
            end if;
         end if;

         Final:= ASU.To_Unbounded_String (PeticionS(Num2..Tamano-2));

         TIO.Put_Line ("TipoPet: " & ASU.To_String(Tipopet) & ASU.To_String(Tipopet));
         TIO.Put_Line ("Inicio:  " & ASU.To_String(Inicio) & ASU.To_String(Inicio));
         TIO.Put_Line ("Maquina: " & ASU.To_String(maquina) & ASU.To_String(Maquina));
         TIO.Put_Line ("Puerto:  " & ASU.To_String(puerto) & ASU.To_String(Puerto));
         TIO.Put_Line ("Dirrel:  " & ASU.To_String(dirrel) & ASU.To_String(Dirrel));
         TIO.Put_Line ("Final:   " & ASU.To_String(final) & ASU.To_String(Final));
      end Separar_URL;


      -- ***************************************************************************************
      -- *        Esta funcin lee de Serv_Conn, una peticin hasta que le llegan dos LF       *
      -- ***************************************************************************************
      function Extraer_Peticion return ASU.Unbounded_String is
         Done, Almost_Done, Comando_Leido: Boolean := False;
         Peticion: ASU.Unbounded_String:= ASU.Null_Unbounded_String;
         A_Char: Character;
      begin
         Done := False;
         while not Done loop
            Character'Read (Serv_Conn'Access, A_Char);
            Peticion:= ASU.To_Unbounded_String (ASU.To_String(Peticion) & A_Char);
            case A_Char is
               when Ada.Characters.Latin_1.LF =>
                  if (not Comando_Leido) then
                     Comando_Leido:=True;
                     Separar_URL (Peticion);
                  end if;

                  if Almost_Done then
                     Done := True;
                  else
                     Almost_Done := True;
                  end if;
               when Ada.Characters.Latin_1.CR =>
                  Almost_Done:= Almost_Done;
               when others =>
                  Almost_Done := False;
            end case;
         end loop;
         return (Peticion);
      end Extraer_Peticion;


      function PagRonda return ASU.Unbounded_String is

         Pag: ASU.Unbounded_String;

      begin
         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        Ada.Characters.Latin_1.LF &
                                        "<HTML><HEAD>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<TITLE>Nmero de ronda</TITLE>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</HEAD><BODY>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<center><H1>Ronda N</H1>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<H3>" & Integer'image(Datos.NRonda) & " </H3></center>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</BODY></HTML>" &
                                        Ada.Characters.Latin_1.LF
                                       );
         return Pag;
      end PagRonda;

      function PagOperaciones return ASU.Unbounded_String is

         Pag: ASU.Unbounded_String;
      begin

         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        ACL.LF &
                                        "<HTML><HEAD>" &
                                        ACL.LF &
                                        "<TITLE>ltimas Operaciones</TITLE>" &
                                        ACL.LF &
                                        "</HEAD><BODY>" &
                                        ACL.LF &
                                        "<center><H1>ltimas operaciones</H1>" &
                                        ACL.LF);
         for Bucle in 1 .. Listas.T_Lista loop
            Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & ASU.To_String(Listas.LOferta(Bucle).Id_Oferta) & " : " & ASU.To_String(Listas.LOferta(Bucle).Id_Ofertante));
            if Listas.LOferta(Bucle).Tip_Ofe='c' then
               Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & " compra ");
            else
               Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & " vende ");
            end if;
            Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & Integer'Image(Listas.LOferta(Bucle).Cantidad) & " acciones a " & Integer'Image(Listas.LOferta(Bucle).Precio) & " euros <BR>");
            Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & ACL.LF);
         end loop;

         Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & " </center>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</BODY></HTML>" &
                                        Ada.Characters.Latin_1.LF
                                       );

         return Pag;
      end PagOperaciones;

      function PagError return ASU.Unbounded_String is
         Pag: ASU.Unbounded_String;
      begin
         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        Ada.Characters.Latin_1.LF &
                                        "<HTML><HEAD>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<TITLE>Pgina no existe</TITLE>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</HEAD><BODY>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<center><H1>No existe la pgina</H1></center>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</BODY></HTML>" &
                                        Ada.Characters.Latin_1.LF
                                       );
         return Pag;

      end PagError;

      function PagEstado return ASU.Unbounded_String is
         Pag: ASU.Unbounded_String;
      begin

         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        ACL.LF &
                                        "<HTML><HEAD>" &
                                        ACL.LF &
                                        "<TITLE>Estado financiero</TITLE>" &
                                        ACL.LF &
                                        "</HEAD><BODY>" &
                                        ACL.LF &
                                        "<center><H1>Estado Financiero: " & ASU.To_String(Datos.Nom_Usu) & " </H1>" &
                                        ACL.LF &
                                        "<H3>" & Integer'Image(Datos.Acciones) & " acciones y " & Integer'Image(Datos.Dinero) & " euros" &
                                        ACL.LF &
                                        "</BODY></HTML>" &
                                        ACL.LF
                                       );
         return Pag;
      end PagEstado;

      function PagFormularioOferta return ASU.Unbounded_String is
         Pag: ASU.Unbounded_String;
      begin

         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        ACL.LF &
                                        "<HTML><HEAD>" &
                                        ACL.LF &
                                        "<TITLE>Estado financiero</TITLE>" &
                                        ACL.LF &
                                        "</HEAD><BODY>" &
                                        ACL.LF &
                                        "<center><H1>Realizar Oferta: </H1>" &
                                        ACL.LF &
                                        "<form action=""http://" & ASU.To_String(Datos.Servidor_IP) & ":" &
                                        Integer'Image(Datos.Servidor_Port)(2..Integer'Image(Datos.Servidor_Port)'Length) & "/opofe" &
                                        " method=get>" &
                                        ACL.LF &
                                        "<input type=hidden name=evaluacion value=""depende del usuario"">" &
                                        ACL.LF &
                                        "Operacion:" &
                                        ACL.LF &
                                        "Compra" &
                                        ACL.LF &
                                        "<input type=radio name=ope value=c>" &
                                        ACL.LF &
                                        "Venta" &
                                        ACL.LF &
                                        "<input type=radio name=ope value=v>" &
                                        ACL.LF &
                                        "<BR>" &
                                        ACL.LF &
                                        "Cantidad: " &
                                        ACL.LF &
                                        "<input type=text name=cantidad size=20>" &
                                        ACL.LF &
                                        "<BR>" &
                                        ACL.LF &
                                        "Precio: " &
                                        ACL.LF &
                                        "<input type=text name=precio size=20>" &
                                        ACL.LF &
                                        "<br>" &
                                        ACL.LF &
                                        "<input type=submit value=""Enviar con GET"">" &
                                        ACL.LF &
                                        "<br>" &
                                        ACL.LF &
                                        "</form></center>" &
                                        ACL.LF &
                                        "</BODY></HTML>" &
                                        ACL.LF
                                       );

         return Pag;

      end PagFormularioOferta;

       function PagFormularioAcepta return ASU.Unbounded_String is
         Pag: ASU.Unbounded_String;
      begin

         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        ACL.LF &
                                        "<HTML><HEAD>" &
                                        ACL.LF &
                                        "<TITLE>Formulario de aceptacin</TITLE>" &
                                        ACL.LF &
                                        "</HEAD><BODY>" &
                                        ACL.LF &
                                        "<center><H1>Realizar Aceptacin: </H1>" &
                                        ACL.LF &
                                        "<form action=""http://" & ASU.To_String(Datos.Servidor_IP) & ":" &
                                        Integer'Image(Datos.Servidor_Port)(2..Integer'Image(Datos.Servidor_Port)'Length) & "/opace" &
                                        " method=get>" &
                                        ACL.LF &
                                        "<BR>" &
                                        ACL.LF &
                                        "<input type=hidden name=evaluacion value=""depende del usuario"">" &
                                        ACL.LF &
                                        "Id_Oferta: " &
                                        ACL.LF &
                                        "<input type=text name=id_oferta size=20>" &
                                        ACL.LF &
                                        "<BR>" &
                                        ACL.LF &
                                        "<input type=submit value=""Enviar con GET"">" &
                                        ACL.LF &
                                        "<br>" &
                                        ACL.LF &
                                        "</form></center>" &
                                        ACL.LF &
                                        "</BODY></HTML>" &
                                        ACL.LF
                                       );

         return Pag;

      end PagFormularioAcepta;

      function Sacar_Tip_Ofe (Cabecer: ASU.Unbounded_String) return Character is
         Resul: Character;
         Ultimo, I, Num: Integer;
         CabecerS: String (1..10000);

      begin
         Ultimo:= ASU.To_String(Cabecer)'Length;
         CabecerS(1..Ultimo):= ASU.To_String(Cabecer);
         Num:= ASU.Index (ASU.To_Unbounded_String(ACH.To_Lower (CabecerS(1..Ultimo))), "ope=");
         if Num>0 then
            I:= Num+4;
            Resul:= CabecerS(I);
         else
            Resul:= ' ';
         end if;
         return (Resul);
      end Sacar_Tip_Ofe;

      function Sacar_Cantidad (Cabecer: ASU.Unbounded_String) return Integer is
         Ultimo, I, Num, Resul: Integer;
         CabecerS: String (1..10000);

      begin
         Ultimo:= ASU.To_String(Cabecer)'Length;
         CabecerS(1..Ultimo):= ASU.To_String(Cabecer);
         Num:= ASU.Index (ASU.To_Unbounded_String(ACH.To_Lower (CabecerS(1..Ultimo))), "cantidad=");
         if Num>0 then
            I:= Num+9;
            while (CabecerS(I)/='&') loop
               I:=I+1;
            end loop;
            Resul:= Integer'Value (CabecerS(Num+9..I-1));
         else
            Resul:= 0;
         end if;
         return (Resul);
      end Sacar_Cantidad;

      function Sacar_Precio (Cabecer: ASU.Unbounded_String) return Integer is
         Ultimo, I, Num, Resul: Integer;
         CabecerS: String (1..10000);

      begin
         Ultimo:= ASU.To_String(Cabecer)'Length;
         CabecerS(1..Ultimo):= ASU.To_String(Cabecer);
         Num:= ASU.Index (ASU.To_Unbounded_String(ACH.To_Lower (CabecerS(1..Ultimo))), "precio=");
         if Num>0 then
            I:= Num+7;
            while (CabecerS(I)/=' ') loop
               I:=I+1;
            end loop;
            Resul:= Integer'Value (CabecerS(Num+7..I-1));
         else
            Resul:= 0;
         end if;
         return (Resul);
      end Sacar_Precio;

      function Sacar_Id_Oferta (Cabecer: ASU.Unbounded_String) return ASU.Unbounded_String is
         Resul: ASU.Unbounded_String;
         Ultimo, I, Num: Integer;
         CabecerS: String (1..10000);

      begin
         Ultimo:= ASU.To_String(Cabecer)'Length;
         CabecerS(1..Ultimo):= ASU.To_String(Cabecer);
         Num:= ASU.Index (ASU.To_Unbounded_String(ACH.To_Lower (CabecerS(1..Ultimo))), "id_oferta=");
         if Num>0 then
            I:= Num+10;
            while (CabecerS(I)/=' ') loop
               I:=I+1;
            end loop;
            Resul:= ASU.To_Unbounded_String(CabecerS(Num+10..I-1));
         else
            Resul:= ASU.To_Unbounded_String("");
         end if;
         return (Resul);
      end Sacar_Id_Oferta;

      function PagOpOfe (Peticion: ASU.Unbounded_String) return ASU.Unbounded_String is

         Pag: ASU.Unbounded_String;
         Mensaje: MEN.Op_Oferta;
      begin

         Mensaje.Tip_Ofe := Sacar_Tip_Ofe (Peticion);
         Mensaje.Cantidad := Sacar_Cantidad (Peticion);
         Mensaje.Precio := Sacar_Precio (Peticion);
         Mensaje.Id_Ofertante := Datos.Nom_Usu;
         Mensaje.Id_Oferta:= ASU.To_Unbounded_String (ASU.To_String(Datos.Nom_Usu)(1..ASU.To_String(Datos.Nom_Usu)'Length) & Integer'Image(Datos.Num_Oferta)(Integer'Image(Datos.Num_Oferta)'First+1..Integer'Image(Datos.Num_Oferta)'Last));
         Datos.Num_Oferta := Datos.Num_Oferta + 1;

         LLUDP.Reset (Send_Stream);
         MEN.Mens'Class'Output (Send_Stream'Access, MEN.Mens'Class(Mensaje));
         LLUDP.Send (Datos.Multi_Address, Send_Stream'access);

         TIO.Put_Line ("He mandado una oferta ");

         Pag:= ASU.To_Unbounded_String ("HTTP/1.1 201 OK" & ACL.CR & ACL.LF & ACL.CR & ACL.LF );

         return Pag;

      end PagOpOfe;

      function PagOpAce (Peticion: ASU.Unbounded_String) return ASU.Unbounded_String is

         Pag: ASU.Unbounded_String;
         Mensaje: MEN.Op_Acepta;
      begin

         Mensaje.Id_Oferta := Sacar_Id_Oferta (Peticion);
         Mensaje.Id_Aceptador := Datos.Nom_Usu;

         LLUDP.Reset (Send_Stream);

         MEN.Mens'Class'Output (Send_Stream'Access, MEN.Mens'Class(Mensaje));

         LLUDP.Send (Datos.Multi_Address, Send_Stream'access);

         TIO.Put_Line ("He mandado una aceptacion ");

         Pag:= ASU.To_Unbounded_String ("HTTP/1.1 201 OK" & ACL.CR & ACL.LF & ACL.CR & ACL.LF );

         return Pag;

      end PagOpAce;


      function PagPrincipal return ASU.Unbounded_String is

         Pag: ASU.Unbounded_String;

      begin

         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        ACL.LF &
                                        "<HTML><HEAD>" &
                                        ACL.LF &
                                        "<TITLE>Juego de la Bolsa</TITLE>" &
                                        ACL.LF &
                                        "</HEAD>" &
                                        ACL.LF &
                                        "<FRAMESET ROWS=15%,30%,55%>" &
                                        ACL.LF &
                                        "<FRAMESET COLS=50%,50%>" &
                                        ACL.LF &
                                        "<FRAME SRC=""/estad"">" &
                                        ACL.LF &
                                        "<FRAME SRC=""/ronda"">" &
                                        ACL.LF &
                                        "</FRAMESET>" &
                                        ACL.LF &
                                         "<FRAMESET COLS=50%,50%>" &
                                        ACL.LF &
                                        "<FRAME SRC=""/forof"">" &
                                        ACL.LF &
                                        "<FRAME SRC=""/forac"">" &
                                        ACL.LF &
                                        "</FRAMESET>" &
                                        ACL.LF &
                                         "<FRAMESET COLS=50%,50%>" &
                                        ACL.LF &
                                        "<FRAME SRC=""/ofert"">" &
                                        ACL.LF &
                                        "<FRAME SRC=""http://" & ASU.To_String (DGON.SerGong_IP) & ":" & Integer'Image(DGON.SerGong_Port)(2..Integer'Image(DGON.SerGong_Port)'Length) & "/"">" &
                                        ACL.LF &
                                        "</FRAMESET>" &
                                        ACL.LF &
                                        "</FRAMESET>" &
                                        ACL.LF &
                                        "</HTML>" &
                                        ACL.LF
                                       );


         TIO.Put_Line ("<FRAME SRC=""http://" & ASU.To_String (DGON.SerGong_IP) & ":" & Integer'Image(DGON.SerGong_Port)(2..Integer'Image(DGON.SerGong_Port)'Length) & "/"">");
         return Pag;
      end PagPrincipal;

      procedure MandarPagina (Pagina: ASU.Unbounded_String) is

      begin
         String'Write (Serv_Conn'Access, ASU.To_String(Pagina));

      end MandarPagina;



   begin

      while (not TerminarTarea) loop
         select
            -- COMIENZA LA TAREA
            accept Start do

               TIO.Put_Line (" Me pongo a escuchar ");

            end Start;

            Datos.Servidor_Address := LLTCP.Build (ASU.To_String(Datos.Servidor_IP), Datos.Servidor_Port);
            TIO.Put_Line (" Me pongo a escuchar ");
            LLTCP.Listen_Connection (Datos.Servidor_Address);
            TIO.Put_Line ("Despus del listen");
            loop
               LLTCP.Wait_Connection (Datos.Servidor_Address, Serv_Conn);
               TIO.Put_Line ("Connection accepted");

               Peticion := Extraer_Peticion;

               TIO.Put_Line (ASU.To_String(Peticion));

               TIO.Put_Line ("Inicio= " & ASU.To_String(Inicio));

               Pagina := ASU.To_Unbounded_String ("");
               if (ASU.To_String(Inicio) = "/ronda") then
                  TIO.Put_Line ("Entro en hacer pgina");
                  Pagina := PagRonda;
               else
                  if (ASU.To_String(Inicio) = "/ofert") then
                     Pagina := PagOperaciones;
                  else
                     if (ASU.To_String(Inicio) = "/estad") then
                        Pagina := PagEstado;
                     else
                        if (ASU.To_String(Inicio) = "/forof") then
                           Pagina:= PagFormularioOferta;
                        else
                           if (ASU.To_String(Inicio) = "/forac") then
                              Pagina:= PagFormularioAcepta;
                           else
                              if (ASU.To_String(Inicio) = "/opofe") then
                                 Pagina := PagOpOfe (Peticion);
                              else
                                 if (ASU.To_String(Inicio) = "/opace") then
                                    Pagina := PagOpAce (Peticion);
                                    -- Esta es la pgina /
                                 else
                                    if (ASU.To_String(Inicio) = "/ HTTP") then
                                       Pagina:= PagPrincipal;
                                    else
                                       Pagina := PagError;
                                    end if;
                                 end if;
                              end if;
                           end if;
                        end if;
                     end if;
                  end if;

               end if;

               MandarPagina (Pagina);

               --Done := False;
               --while not Done loop
               --   Character'Read (Serv_Conn'Access, A_Char);
               --  case A_Char is
               --      when Ada.Characters.Latin_1.LF =>
               --         TIO.Put_Line ("(LF)");
               --         if Almost_Done then
               --            Done := True;
               --         else
               --            Almost_Done := True;
               --         end if;
               --      when Ada.Characters.Latin_1.CR =>
               --         TIO.Put ("(CR)");
               --      when others =>
               --         TIO.Put (A_Char);
               --         Almost_Done := False;
               --  end case;
               --end loop;
               --String'Write
               --  (Serv_Conn'Access, Dummy_Reply_Header);
               --String'Write
               --  (Serv_Conn'Access, Integer'Image (89));
               --String'Write
               --   (Serv_Conn'Access, Dummy_Reply_Footer);
               --Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
               --
               --
               LLTCP.Dispose (Serv_Conn);
               TIO.Put_Line ("Connection closed by server");

            end loop;

         or
            accept Stop do
               TerminarTarea:= True;
            end Stop;
         end select;
      end loop;
   end Servidor_HTTP;
end Broker_HTTP;
