
with Ada.Strings.Unbounded;
with Lower_Layer_UDP;

package Mensajes_Bolsa is

   package ASU renames Ada.Strings.Unbounded;
   package LLUDP renames Lower_Layer_UDP;

   type Mens is abstract tagged null record;

   -------------------------------------------------------------------
   -- Funcion para procesar los mensajes
   -------------------------------------------------------------------
   procedure Procesar (Mensaje: in Mens) is abstract;

   -- Request for new user name.

   --type Pet_Usu_Nue is new Mens with record
   --type Pet_Usu_Nue is record
   --   Dir_Res: Lower_Layer_UDP.End_Point_Type;
   --  Nom_Usu: ASU.Unbounded_String;
   --end record;

   --procedure Procesar (Mensaje: in Pet_Usu_Nue);

   -------------------------------------------------------------------
   -- Reply in case proposed name is already in use.
   -------------------------------------------------------------------

   --type Res_Nom_Usu_Usado is new Mens with record
   --   Nom_Usu: ASU.Unbounded_String;
   --end record;

   --procedure Procesar (Mensaje: in Res_Nom_Usu_Usado);

   -------------------------------------------------------------------
   -- Information of new user.
   -------------------------------------------------------------------

   type Inf_Nue_Usu is new Mens with record
      Nom_Usu: ASU.Unbounded_String;
      Dinero: Integer;
      Acciones: Integer;
   end record;

   procedure Procesar (Mensaje: in Inf_Nue_Usu);

   -------------------------------------------------------------------
   -- Information of user leaving.
   -------------------------------------------------------------------

   type Inf_Usu_Sal is new Mens with record
      Nom_Usu: ASU.Unbounded_String;
   end record;

   procedure Procesar (Mensaje: in Inf_Usu_Sal);

   -------------------------------------------------------------------
   -- Operacion de oferta (compra/venta)
   -------------------------------------------------------------------

   type Op_Oferta is new Mens with record
      Tip_Ofe: character;
      Cantidad: Integer;
      Precio: Integer;
      Id_Ofertante: ASU.Unbounded_String;
      Id_Oferta: ASU.Unbounded_String;
   end record;


   procedure Procesar (Mensaje: in Op_Oferta);

   -------------------------------------------------------------------
   -- Operacion de aceptacion
   -------------------------------------------------------------------

   type Op_Acepta is new Mens with record
      Id_Oferta: ASU.Unbounded_String;
      Id_Aceptador: ASU.Unbounded_String;
   end record;

   procedure Procesar (Mensaje: in Op_Acepta);

   -------------------------------------------------------------------
   -- Gong
   -------------------------------------------------------------------

   type Inf_Gong is new Mens with record
      N_Ronda: Integer;
   end record;

   procedure Procesar (Mensaje: in Inf_Gong);

   -------------------------------------------------------------------
   -- Mensaje de compromiso
   -------------------------------------------------------------------

   type Compro is new Mens with record
      Id_Oferta: ASU.Unbounded_String;
      Id_Aceptador: ASU.Unbounded_String;
   end record;

   procedure Procesar (Mensaje: in Compro);

end mensajes_bolsa;







